/* Java Pointset_Powerset_C_Polyhedron interface code.
   Copyright (C) 2001-2009 Roberto Bagnara <bagnara@cs.unipr.it>

This file is part of the Parma Polyhedra Library (PPL).

The PPL is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 3 of the License, or (at your
option) any later version.

The PPL is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation,
Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02111-1307, USA.

For the most up-to-date information see the Parma Polyhedra Library
site: http://www.cs.unipr.it/ppl/ . */

#include "ppl_java_common.defs.hh"
#include "parma_polyhedra_library_Pointset_Powerset_C_Polyhedron.h"
using namespace Parma_Polyhedra_Library;
using namespace Parma_Polyhedra_Library::Interfaces::Java;

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_finalize
(JNIEnv* env, jobject j_this) try {
  if (!is_java_marked(env, j_this)) {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    delete this_ptr;
  }
}
CATCH_ALL






JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_build_1cpp_1object__JLparma_1polyhedra_1library_Degenerate_1Element_2
(JNIEnv* env, jobject j_this, jlong j_dim, jobject j_degenerate_element) try {
  dimension_type ppl_dim = jtype_to_unsigned<dimension_type>(j_dim);
  jclass degenerate_element_class
    = env->FindClass("parma_polyhedra_library/Degenerate_Element");
  jmethodID degenerate_element_ordinal_id
    = env->GetMethodID(degenerate_element_class, "ordinal", "()I");
  jint j_degenerate_element_int
    = env->CallIntMethod(j_degenerate_element, degenerate_element_ordinal_id);
  Pointset_Powerset<C_Polyhedron>* this_ptr;
  switch (j_degenerate_element_int) {
  case 0:
    this_ptr = new Pointset_Powerset<C_Polyhedron>(ppl_dim, UNIVERSE);
    break;
  case 1:
    this_ptr = new Pointset_Powerset<C_Polyhedron>(ppl_dim, EMPTY);
    break;
  default:
    throw std::runtime_error("PPL Java interface internal error");
  }
  set_ptr(env, j_this, this_ptr);
}
CATCH_ALL






JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_build_1cpp_1object__Lparma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_2
(JNIEnv* env, jobject  j_this, jobject j_y) try {
  Pointset_Powerset<C_Polyhedron>* y_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
  Pointset_Powerset<C_Polyhedron>* this_ptr = new Pointset_Powerset<C_Polyhedron>(*y_ptr);
  set_ptr(env, j_this, this_ptr);
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_build_1cpp_1object__Lparma_1polyhedra_1library_C_1Polyhedron_2
(JNIEnv* env, jobject  j_this, jobject j_y) try {
  C_Polyhedron* y_ptr
    = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_y));
  Pointset_Powerset<C_Polyhedron>* this_ptr = new Pointset_Powerset<C_Polyhedron>(*y_ptr);
  set_ptr(env, j_this, this_ptr);
}
CATCH_ALL







JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_build_1cpp_1object__Lparma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_2Lparma_1polyhedra_1library_Complexity_1Class_2
(JNIEnv* env, jobject j_this, jobject j_y, jobject j_complexity) try {
  Pointset_Powerset<C_Polyhedron>* y_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
  jclass complexity_class
    = env->FindClass("parma_polyhedra_library/Complexity_Class");
  jmethodID complexity_ordinal_id
    = env->GetMethodID(complexity_class, "ordinal", "()I");
  jint j_complexity_int
    = env->CallIntMethod(j_complexity, complexity_ordinal_id);
  Pointset_Powerset<C_Polyhedron>* this_ptr;
  switch (j_complexity_int) {
  case 0:
    this_ptr = new Pointset_Powerset<C_Polyhedron>(*y_ptr, POLYNOMIAL_COMPLEXITY);
    break;
  case 1:
    this_ptr = new Pointset_Powerset<C_Polyhedron>(*y_ptr, SIMPLEX_COMPLEXITY);
    break;
  case 2:
    this_ptr = new Pointset_Powerset<C_Polyhedron>(*y_ptr, ANY_COMPLEXITY);
    break;
  default:
    throw std::runtime_error("PPL Java interface internal error");
  }
  set_ptr(env, j_this, this_ptr);
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_build_1cpp_1object__Lparma_1polyhedra_1library_C_1Polyhedron_2Lparma_1polyhedra_1library_Complexity_1Class_2
(JNIEnv* env, jobject j_this, jobject j_y, jobject j_complexity) try {
  C_Polyhedron* y_ptr
    = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_y));
  jclass complexity_class
    = env->FindClass("parma_polyhedra_library/Complexity_Class");
  jmethodID complexity_ordinal_id
    = env->GetMethodID(complexity_class, "ordinal", "()I");
  jint j_complexity_int
    = env->CallIntMethod(j_complexity, complexity_ordinal_id);
  Pointset_Powerset<C_Polyhedron>* this_ptr;
  switch (j_complexity_int) {
  case 0:
    this_ptr = new Pointset_Powerset<C_Polyhedron>(*y_ptr, POLYNOMIAL_COMPLEXITY);
    break;
  case 1:
    this_ptr = new Pointset_Powerset<C_Polyhedron>(*y_ptr, SIMPLEX_COMPLEXITY);
    break;
  case 2:
    this_ptr = new Pointset_Powerset<C_Polyhedron>(*y_ptr, ANY_COMPLEXITY);
    break;
  default:
    throw std::runtime_error("PPL Java interface internal error");
  }
  set_ptr(env, j_this, this_ptr);
}
CATCH_ALL







JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_build_1cpp_1object__Lparma_1polyhedra_1library_Constraint_1System_2
(JNIEnv* env, jobject j_this, jobject j_iterable) try {
  Constraint_System cs
    = build_cxx_constraint_system(env, j_iterable);
  Pointset_Powerset<C_Polyhedron>* this_ptr = new Pointset_Powerset<C_Polyhedron>(cs);
  set_ptr(env, j_this, this_ptr);
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_build_1cpp_1object__Lparma_1polyhedra_1library_Congruence_1System_2
(JNIEnv* env, jobject j_this, jobject j_iterable) try {
  Congruence_System cs
    = build_cxx_congruence_system(env, j_iterable);
  Pointset_Powerset<C_Polyhedron>* this_ptr = new Pointset_Powerset<C_Polyhedron>(cs);
  set_ptr(env, j_this, this_ptr);
}
CATCH_ALL








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_swap
(JNIEnv* env, jobject j_this, jobject j_y) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Pointset_Powerset<C_Polyhedron>* y_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
  this_ptr->swap(*y_ptr);
}
CATCH_ALL





JNIEXPORT jlong JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_space_1dimension
(JNIEnv* env, jobject j_this) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    return this_ptr->space_dimension();
  }
  CATCH_ALL;
  return 0;
}

JNIEXPORT jlong JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_affine_1dimension
(JNIEnv* env, jobject j_this) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    return this_ptr->affine_dimension();
  }
  CATCH_ALL;
  return 0;
}






JNIEXPORT jobject JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_relation_1with__Lparma_1polyhedra_1library_Constraint_2
(JNIEnv* env, jobject j_this, jobject j_c) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    Constraint c = build_cxx_constraint(env, j_c);
    Poly_Con_Relation pcr = this_ptr->relation_with(c);
    return build_java_poly_con_relation(env, pcr);
  }
  CATCH_ALL;
  jobject null = 0;
  return null;
}

JNIEXPORT jobject JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_relation_1with__Lparma_1polyhedra_1library_Generator_2
(JNIEnv* env, jobject j_this, jobject j_c) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    Generator c = build_cxx_generator(env, j_c);
    Poly_Gen_Relation pcr = this_ptr->relation_with(c);
    return build_java_poly_gen_relation(env, pcr);
  }
  CATCH_ALL;
  jobject null = 0;
  return null;
}

JNIEXPORT jobject JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_relation_1with__Lparma_1polyhedra_1library_Congruence_2
(JNIEnv* env, jobject j_this, jobject j_c) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    Congruence c = build_cxx_congruence(env, j_c);
    Poly_Con_Relation pcr = this_ptr->relation_with(c);
    return build_java_poly_con_relation(env, pcr);
  }
  CATCH_ALL;
  jobject null = 0;
  return null;
}






JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_is_1empty
(JNIEnv* env, jobject j_this) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    return this_ptr->is_empty();
  }
  CATCH_ALL;
  return false;
}

JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_is_1universe
(JNIEnv* env, jobject j_this) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    return this_ptr->is_universe();
  }
  CATCH_ALL;
  return false;
}

JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_is_1bounded
(JNIEnv* env, jobject j_this) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    return this_ptr->is_bounded();
  }
  CATCH_ALL;
  return false;
}

JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_contains_1integer_1point
(JNIEnv* env, jobject j_this) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    return this_ptr->contains_integer_point();
  }
  CATCH_ALL;
  return false;
}

JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_is_1topologically_1closed
(JNIEnv* env, jobject j_this) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    return this_ptr->is_topologically_closed();
  }
  CATCH_ALL;
  return false;
}

JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_is_1discrete
(JNIEnv* env, jobject j_this) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    return this_ptr->is_discrete();
  }
  CATCH_ALL;
  return false;
}






JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_topological_1closure_1assign
(JNIEnv* env, jobject j_this) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  this_ptr->topological_closure_assign();
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_pairwise_1reduce
(JNIEnv* env, jobject j_this) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  this_ptr->pairwise_reduce();
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_omega_1reduce
(JNIEnv* env, jobject j_this) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  this_ptr->omega_reduce();
}
CATCH_ALL






JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_bounds_1from_1above
(JNIEnv* env, jobject j_this, jobject j_le) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    Linear_Expression le = build_cxx_linear_expression(env, j_le);
    return this_ptr->bounds_from_above(le);
  }
  CATCH_ALL;
  return false;
}

JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_bounds_1from_1below
(JNIEnv* env, jobject j_this, jobject j_le) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    Linear_Expression le = build_cxx_linear_expression(env, j_le);
    return this_ptr->bounds_from_below(le);
  }
  CATCH_ALL;
  return false;
}






JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_maximize__Lparma_1polyhedra_1library_Linear_1Expression_2Lparma_1polyhedra_1library_Coefficient_2Lparma_1polyhedra_1library_Coefficient_2Lparma_1polyhedra_1library_By_1Reference_2
(JNIEnv* env, jobject j_this, jobject j_le,
 jobject j_num, jobject j_den, jobject j_ref_boolean) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    PPL_DIRTY_TEMP_COEFFICIENT(num);
    PPL_DIRTY_TEMP_COEFFICIENT(den);
    num = build_cxx_coeff(env, j_num);
    den = build_cxx_coeff(env, j_den);
    Linear_Expression le = build_cxx_linear_expression(env, j_le);
    bool b_value;
    if (this_ptr->maximize(le, num, den, b_value)) {
      jobject j_num_result = build_java_coeff(env, num);
      jobject j_den_result = build_java_coeff(env, den);
      set_coefficient(env, j_num, j_num_result);
      set_coefficient(env, j_den, j_den_result);
      jobject j_boolean = bool_to_j_boolean(env, b_value);
      set_by_reference(env, j_ref_boolean, j_boolean);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return false;
}

JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_minimize__Lparma_1polyhedra_1library_Linear_1Expression_2Lparma_1polyhedra_1library_Coefficient_2Lparma_1polyhedra_1library_Coefficient_2Lparma_1polyhedra_1library_By_1Reference_2
(JNIEnv* env, jobject j_this, jobject j_le,
 jobject j_num, jobject j_den, jobject j_ref_boolean) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    PPL_DIRTY_TEMP_COEFFICIENT(num);
    PPL_DIRTY_TEMP_COEFFICIENT(den);
    num = build_cxx_coeff(env, j_num);
    den = build_cxx_coeff(env, j_den);
    Linear_Expression le = build_cxx_linear_expression(env, j_le);
    bool b_value;
    if (this_ptr->minimize(le, num, den, b_value)) {
      jobject j_num_result = build_java_coeff(env, num);
      jobject j_den_result = build_java_coeff(env, den);
      set_coefficient(env, j_num, j_num_result);
      set_coefficient(env, j_den, j_den_result);
      jobject j_boolean = bool_to_j_boolean(env, b_value);
      set_by_reference(env, j_ref_boolean, j_boolean);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return false;
}






JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_maximize__Lparma_1polyhedra_1library_Linear_1Expression_2Lparma_1polyhedra_1library_Coefficient_2Lparma_1polyhedra_1library_Coefficient_2Lparma_1polyhedra_1library_By_1Reference_2Lparma_1polyhedra_1library_Generator_2
(JNIEnv* env, jobject j_this, jobject j_le,
 jobject j_num, jobject j_den, jobject j_ref_boolean, jobject j_g) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    PPL_DIRTY_TEMP_COEFFICIENT(num);
    PPL_DIRTY_TEMP_COEFFICIENT(den);
    num = build_cxx_coeff(env, j_num);
    den = build_cxx_coeff(env, j_den);
    Linear_Expression le = build_cxx_linear_expression(env, j_le);
    bool b_value;
    Generator g = point();
    if (this_ptr->maximize(le, num, den, b_value, g)) {
      jobject j_num_result = build_java_coeff(env, num);
      jobject j_den_result = build_java_coeff(env, den);
      jobject j_g_result = build_java_generator(env, g);
      set_coefficient(env, j_num, j_num_result);
      set_coefficient(env, j_den, j_den_result);
      jobject j_boolean = bool_to_j_boolean(env, b_value);
      set_by_reference(env, j_ref_boolean, j_boolean);
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return false;
}

JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_minimize__Lparma_1polyhedra_1library_Linear_1Expression_2Lparma_1polyhedra_1library_Coefficient_2Lparma_1polyhedra_1library_Coefficient_2Lparma_1polyhedra_1library_By_1Reference_2Lparma_1polyhedra_1library_Generator_2
(JNIEnv* env, jobject j_this, jobject j_le,
 jobject j_num, jobject j_den, jobject j_ref_boolean, jobject j_g) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    PPL_DIRTY_TEMP_COEFFICIENT(num);
    PPL_DIRTY_TEMP_COEFFICIENT(den);
    num = build_cxx_coeff(env, j_num);
    den = build_cxx_coeff(env, j_den);
    Linear_Expression le = build_cxx_linear_expression(env, j_le);
    bool b_value;
    Generator g = point();
    if (this_ptr->minimize(le, num, den, b_value, g)) {
      jobject j_num_result = build_java_coeff(env, num);
      jobject j_den_result = build_java_coeff(env, den);
      jobject j_g_result = build_java_generator(env, g);
      set_coefficient(env, j_num, j_num_result);
      set_coefficient(env, j_den, j_den_result);
      jobject j_boolean = bool_to_j_boolean(env, b_value);
      set_by_reference(env, j_ref_boolean, j_boolean);
      set_generator(env, j_g, j_g_result);
      return true;
    }
    return false;
  }
  CATCH_ALL;
  return false;
}






JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_contains
(JNIEnv* env, jobject j_this, jobject j_y) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    Pointset_Powerset<C_Polyhedron>* y_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
    return this_ptr->contains(*y_ptr);
  }
  CATCH_ALL;
  return false;
}

JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_strictly_1contains
(JNIEnv* env, jobject j_this, jobject j_y) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    Pointset_Powerset<C_Polyhedron>* y_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
    return this_ptr->strictly_contains(*y_ptr);
  }
  CATCH_ALL;
  return false;
}

JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_is_1disjoint_1from
(JNIEnv* env, jobject j_this, jobject j_y) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    Pointset_Powerset<C_Polyhedron>* y_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
    return this_ptr->is_disjoint_from(*y_ptr);
  }
  CATCH_ALL;
  return false;
}

JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_geometrically_1covers
(JNIEnv* env, jobject j_this, jobject j_y) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    Pointset_Powerset<C_Polyhedron>* y_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
    return this_ptr->geometrically_covers(*y_ptr);
  }
  CATCH_ALL;
  return false;
}

JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_geometrically_1equals
(JNIEnv* env, jobject j_this, jobject j_y) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    Pointset_Powerset<C_Polyhedron>* y_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
    return this_ptr->geometrically_equals(*y_ptr);
  }
  CATCH_ALL;
  return false;
}






JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_equals
(JNIEnv* env, jobject j_this, jobject j_y) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    Pointset_Powerset<C_Polyhedron>* y_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
    return *this_ptr == *y_ptr;
  }
  CATCH_ALL;
  return false;
}





JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_OK
(JNIEnv* env, jobject j_this) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    return this_ptr->OK();
  }
  CATCH_ALL;
  return false;
}





JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_add_1constraint
(JNIEnv* env, jobject j_this, jobject j_c) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Constraint c = build_cxx_constraint(env, j_c);
  this_ptr->add_constraint(c);
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_add_1congruence
(JNIEnv* env, jobject j_this, jobject j_c) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Congruence c = build_cxx_congruence(env, j_c);
  this_ptr->add_congruence(c);
}
CATCH_ALL






JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_add_1constraints
(JNIEnv* env, jobject j_this, jobject j_cs) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Constraint_System cs = build_cxx_constraint_system(env, j_cs);
  this_ptr->add_constraints(cs);
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_add_1congruences
(JNIEnv* env, jobject j_this, jobject j_cs) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Congruence_System cs = build_cxx_congruence_system(env, j_cs);
  this_ptr->add_congruences(cs);
}
CATCH_ALL






JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_refine_1with_1constraint
(JNIEnv* env, jobject j_this, jobject j_c) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Constraint c = build_cxx_constraint(env, j_c);
  this_ptr->refine_with_constraint(c);
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_refine_1with_1congruence
(JNIEnv* env, jobject j_this, jobject j_c) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Congruence c = build_cxx_congruence(env, j_c);
  this_ptr->refine_with_congruence(c);
}
CATCH_ALL






JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_refine_1with_1constraints
(JNIEnv* env, jobject j_this, jobject j_cs) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Constraint_System cs
    = build_cxx_constraint_system(env, j_cs);
  this_ptr->refine_with_constraints(cs);
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_refine_1with_1congruences
(JNIEnv* env, jobject j_this, jobject j_cs) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Congruence_System cs
    = build_cxx_congruence_system(env, j_cs);
  this_ptr->refine_with_congruences(cs);
}
CATCH_ALL






JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_intersection_1assign
(JNIEnv* env, jobject j_this, jobject j_y) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Pointset_Powerset<C_Polyhedron>* y_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
  this_ptr->intersection_assign(*y_ptr);
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_upper_1bound_1assign
(JNIEnv* env, jobject j_this, jobject j_y) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Pointset_Powerset<C_Polyhedron>* y_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
  this_ptr->upper_bound_assign(*y_ptr);
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_difference_1assign
(JNIEnv* env, jobject j_this, jobject j_y) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Pointset_Powerset<C_Polyhedron>* y_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
  this_ptr->difference_assign(*y_ptr);
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_concatenate_1assign
(JNIEnv* env, jobject j_this, jobject j_y) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Pointset_Powerset<C_Polyhedron>* y_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
  this_ptr->concatenate_assign(*y_ptr);
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_time_1elapse_1assign
(JNIEnv* env, jobject j_this, jobject j_y) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Pointset_Powerset<C_Polyhedron>* y_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
  this_ptr->time_elapse_assign(*y_ptr);
}
CATCH_ALL






JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_upper_1bound_1assign_1if_1exact
(JNIEnv* env, jobject j_this, jobject j_y) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    Pointset_Powerset<C_Polyhedron>* y_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
    return this_ptr->upper_bound_assign_if_exact(*y_ptr);
  }
  CATCH_ALL;
  return false;
}







JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_simplify_1using_1context_1assign
(JNIEnv* env, jobject j_this, jobject j_y) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    Pointset_Powerset<C_Polyhedron>* y_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
    return this_ptr->simplify_using_context_assign(*y_ptr);
  }
  CATCH_ALL;
  return false;
}





JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_constrains
(JNIEnv* env, jobject j_this, jobject j_var) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    Variable v = build_cxx_variable(env, j_var);
    return this_ptr->constrains(v);
  }
  CATCH_ALL;
  return false;
}





JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_unconstrain_1space_1dimension
(JNIEnv* env, jobject j_this, jobject j_var) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Variable v = build_cxx_variable(env, j_var);
  this_ptr->unconstrain(v);
}
CATCH_ALL





JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_unconstrain_1space_1dimensions
(JNIEnv* env, jobject j_this, jobject j_v_set) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Variables_Set v_set = build_cxx_variables_set(env, j_v_set);
  this_ptr->unconstrain(v_set);
}
CATCH_ALL





JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_affine_1image
(JNIEnv* env, jobject j_this, jobject j_v, jobject j_le, jobject j_c) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Variable v = build_cxx_variable(env, j_v);
  Linear_Expression le = build_cxx_linear_expression(env, j_le);
  PPL_DIRTY_TEMP_COEFFICIENT(c);
  c = build_cxx_coeff(env, j_c);
  this_ptr->affine_image(v, le, c);
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_affine_1preimage
(JNIEnv* env, jobject j_this, jobject j_v, jobject j_le, jobject j_c) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Variable v = build_cxx_variable(env, j_v);
  Linear_Expression le = build_cxx_linear_expression(env, j_le);
  PPL_DIRTY_TEMP_COEFFICIENT(c);
  c = build_cxx_coeff(env, j_c);
  this_ptr->affine_preimage(v, le, c);
}
CATCH_ALL






JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_bounded_1affine_1image
(JNIEnv* env, jobject j_this,
 jobject j_v, jobject j_lhs, jobject j_rhs, jobject j_c) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Variable v = build_cxx_variable(env, j_v);
  Linear_Expression lhs = build_cxx_linear_expression(env, j_lhs);
  Linear_Expression rhs = build_cxx_linear_expression(env, j_rhs);
  PPL_DIRTY_TEMP_COEFFICIENT(c);
  c = build_cxx_coeff(env, j_c);
  this_ptr->bounded_affine_image(v, lhs, rhs, c);
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_bounded_1affine_1preimage
(JNIEnv* env, jobject j_this,
 jobject j_v, jobject j_lhs, jobject j_rhs, jobject j_c) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Variable v = build_cxx_variable(env, j_v);
  Linear_Expression lhs = build_cxx_linear_expression(env, j_lhs);
  Linear_Expression rhs = build_cxx_linear_expression(env, j_rhs);
  PPL_DIRTY_TEMP_COEFFICIENT(c);
  c = build_cxx_coeff(env, j_c);
  this_ptr->bounded_affine_preimage(v, lhs, rhs, c);
}
CATCH_ALL






JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_generalized_1affine_1image__Lparma_1polyhedra_1library_Variable_2Lparma_1polyhedra_1library_Relation_1Symbol_2Lparma_1polyhedra_1library_Linear_1Expression_2Lparma_1polyhedra_1library_Coefficient_2
(JNIEnv* env, jobject j_this,
 jobject j_v, jobject j_relsym, jobject j_le, jobject j_c) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Variable v = build_cxx_variable(env, j_v);
  Relation_Symbol relsym = build_cxx_relsym(env, j_relsym);
  Linear_Expression le = build_cxx_linear_expression(env, j_le);
  PPL_DIRTY_TEMP_COEFFICIENT(c);
  c = build_cxx_coeff(env, j_c);
  this_ptr->generalized_affine_image(v, relsym, le, c);
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_generalized_1affine_1preimage__Lparma_1polyhedra_1library_Variable_2Lparma_1polyhedra_1library_Relation_1Symbol_2Lparma_1polyhedra_1library_Linear_1Expression_2Lparma_1polyhedra_1library_Coefficient_2
(JNIEnv* env, jobject j_this,
 jobject j_v, jobject j_relsym, jobject j_le, jobject j_c) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Variable v = build_cxx_variable(env, j_v);
  Relation_Symbol relsym = build_cxx_relsym(env, j_relsym);
  Linear_Expression le = build_cxx_linear_expression(env, j_le);
  PPL_DIRTY_TEMP_COEFFICIENT(c);
  c = build_cxx_coeff(env, j_c);
  this_ptr->generalized_affine_preimage(v, relsym, le, c);
}
CATCH_ALL






JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_generalized_1affine_1image__Lparma_1polyhedra_1library_Linear_1Expression_2Lparma_1polyhedra_1library_Relation_1Symbol_2Lparma_1polyhedra_1library_Linear_1Expression_2
(JNIEnv* env, jobject j_this,
 jobject j_lhs, jobject j_relsym, jobject j_rhs) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Linear_Expression lhs = build_cxx_linear_expression(env, j_lhs);
  Linear_Expression rhs = build_cxx_linear_expression(env, j_rhs);
  Relation_Symbol relsym = build_cxx_relsym(env, j_relsym);
  this_ptr->generalized_affine_image(lhs, relsym, rhs);
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_generalized_1affine_1preimage__Lparma_1polyhedra_1library_Linear_1Expression_2Lparma_1polyhedra_1library_Relation_1Symbol_2Lparma_1polyhedra_1library_Linear_1Expression_2
(JNIEnv* env, jobject j_this,
 jobject j_lhs, jobject j_relsym, jobject j_rhs) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Linear_Expression lhs = build_cxx_linear_expression(env, j_lhs);
  Linear_Expression rhs = build_cxx_linear_expression(env, j_rhs);
  Relation_Symbol relsym = build_cxx_relsym(env, j_relsym);
  this_ptr->generalized_affine_preimage(lhs, relsym, rhs);
}
CATCH_ALL






JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_add_1space_1dimensions_1and_1embed
(JNIEnv* env, jobject j_this, jlong dim) try {
  dimension_type ppl_dim = jtype_to_unsigned<dimension_type>(dim);
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  this_ptr->add_space_dimensions_and_embed(ppl_dim);
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_add_1space_1dimensions_1and_1project
(JNIEnv* env, jobject j_this, jlong dim) try {
  dimension_type ppl_dim = jtype_to_unsigned<dimension_type>(dim);
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  this_ptr->add_space_dimensions_and_project(ppl_dim);
}
CATCH_ALL






JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_remove_1space_1dimensions
(JNIEnv* env, jobject j_this, jobject j_v_set) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Variables_Set v_set = build_cxx_variables_set(env, j_v_set);
  this_ptr->remove_space_dimensions(v_set);
}
CATCH_ALL





JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_remove_1higher_1space_1dimensions
(JNIEnv* env, jobject j_this, jlong dim) try {
  dimension_type ppl_dim = jtype_to_unsigned<dimension_type>(dim);
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  this_ptr->remove_higher_space_dimensions(ppl_dim);
}
CATCH_ALL





JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_expand_1space_1dimension
(JNIEnv* env, jobject j_this, jobject j_variable, jlong dim) try {
  dimension_type ppl_dim = jtype_to_unsigned<dimension_type>(dim);
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Variable v = build_cxx_variable(env, j_variable);
  this_ptr->expand_space_dimension(v, ppl_dim);
}
CATCH_ALL





JNIEXPORT void JNICALL Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_fold_1space_1dimensions
(JNIEnv* env, jobject j_this, jobject j_v_set, jobject j_var) try {
  Variables_Set v_set = build_cxx_variables_set(env, j_v_set);
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Variable v = build_cxx_variable(env, j_var);
  this_ptr->fold_space_dimensions(v_set, v);
}
CATCH_ALL





JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_map_1space_1dimensions
(JNIEnv* env, jobject j_this, jobject j_p_func) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Partial_Function ppl_pfunc(j_p_func, env);
  this_ptr->map_space_dimensions(ppl_pfunc);
}
CATCH_ALL





JNIEXPORT jstring JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_ascii_1dump
(JNIEnv* env, jobject j_this) {
  try {
    using namespace Parma_Polyhedra_Library::IO_Operators;
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    std::ostringstream s;
    this_ptr->ascii_dump(s);
    std::string str = s.str();
    return env->NewStringUTF(str.c_str());
  }
  CATCH_ALL;
  return 0;
}





JNIEXPORT jlong JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_external_1memory_1in_1bytes
(JNIEnv* env, jobject j_this) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    return this_ptr->external_memory_in_bytes();
  }
  CATCH_ALL;
  return 0;
}

JNIEXPORT jlong JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_total_1memory_1in_1bytes
(JNIEnv* env, jobject j_this) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    return this_ptr->total_memory_in_bytes();
  }
  CATCH_ALL;
  return 0;
}

JNIEXPORT jlong JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_size
(JNIEnv* env, jobject j_this) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    return this_ptr->size();
  }
  CATCH_ALL;
  return 0;
}






#include "parma_polyhedra_library_Pointset_Powerset_C_Polyhedron_Iterator.h"

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_1Iterator_build_1cpp_1object
(JNIEnv* env, jobject j_this, jobject j_y) try {
  Pointset_Powerset<C_Polyhedron>::iterator* y_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>::iterator*>(get_ptr(env, j_y));
  Pointset_Powerset<C_Polyhedron>::iterator* this_ptr
    = new Pointset_Powerset<C_Polyhedron>::iterator(*y_ptr);
  set_ptr(env, j_this, this_ptr);
}
CATCH_ALL





JNIEXPORT jobject JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_begin_1iterator
(JNIEnv* env, jobject j_this) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    jclass j_it_class
      = env->FindClass("parma_polyhedra_library/Pointset_Powerset_C_Polyhedron_Iterator");
    jmethodID j_it_ctr_id = env->GetMethodID(j_it_class, "<init>", "()V");
    jobject j_it = env->NewObject(j_it_class, j_it_ctr_id);
    Pointset_Powerset<C_Polyhedron>::iterator* ppl_it
      = new Pointset_Powerset<C_Polyhedron>::iterator(this_ptr->begin());
    set_ptr(env, j_it, ppl_it);
    return j_it;
  }
  CATCH_ALL;
  jobject null = 0;
  return null;
}

JNIEXPORT jobject JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_end_1iterator
(JNIEnv* env, jobject j_this) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    jclass j_it_class
      = env->FindClass("parma_polyhedra_library/Pointset_Powerset_C_Polyhedron_Iterator");
    jmethodID j_it_ctr_id = env->GetMethodID(j_it_class, "<init>", "()V");
    jobject j_it = env->NewObject(j_it_class, j_it_ctr_id);
    Pointset_Powerset<C_Polyhedron>::iterator* ppl_it
      = new Pointset_Powerset<C_Polyhedron>::iterator(this_ptr->end());
    set_ptr(env, j_it, ppl_it);
    return j_it;
  }
  CATCH_ALL;
  jobject null = 0;
  return null;
}







JNIEXPORT jboolean JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_1Iterator_equals
(JNIEnv* env, jobject j_this, jobject j_y) {
  try {
    Pointset_Powerset<C_Polyhedron>::iterator* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>::iterator*>(get_ptr(env, j_this));
    Pointset_Powerset<C_Polyhedron>::iterator* y_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>::iterator*>(get_ptr(env, j_y));
    return *this_ptr == *y_ptr;
  }
  CATCH_ALL;
  return false;
}





JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_1Iterator_next
(JNIEnv* env, jobject j_this) try {
  Pointset_Powerset<C_Polyhedron>::iterator* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>::iterator*>(get_ptr(env, j_this));
  ++(*this_ptr);
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_1Iterator_prev
(JNIEnv* env, jobject j_this) try {
  Pointset_Powerset<C_Polyhedron>::iterator* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>::iterator*>(get_ptr(env, j_this));
  --(*this_ptr);
}
CATCH_ALL







JNIEXPORT jobject JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_1Iterator_get_1disjunct
(JNIEnv* env, jobject j_this) {
  try {
    Pointset_Powerset<C_Polyhedron>::iterator* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>::iterator*>(get_ptr(env, j_this));
    jclass j_class = env->FindClass("parma_polyhedra_library/C_Polyhedron");
    jmethodID j_ctr_id = env->GetMethodID(j_class, "<init>", "()V");
    jobject j_obj = env->NewObject(j_class, j_ctr_id);
    set_ptr(env, j_obj,  &((*this_ptr)->element()), true);
    return j_obj;
  }
  CATCH_ALL;
  jobject null = 0;
  return null;
}








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_1Iterator_free
(JNIEnv* env, jobject j_this) try {
  if (!is_java_marked(env, j_this)) {
    Pointset_Powerset<C_Polyhedron>::iterator* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>::iterator*>(get_ptr(env, j_this));
    delete this_ptr;
    void* null_ptr = 0;
    set_ptr(env, j_this, null_ptr);
  }
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_1Iterator_finalize
(JNIEnv* env, jobject j_this) try {
  if (!is_java_marked(env, j_this)) {
    Pointset_Powerset<C_Polyhedron>::iterator* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>::iterator*>(get_ptr(env, j_this));
    delete this_ptr;
  }
}
CATCH_ALL





JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_add_1disjunct
(JNIEnv* env, jobject j_this, jobject j_d) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  C_Polyhedron* d_ptr
    = reinterpret_cast<C_Polyhedron*>(get_ptr(env, j_d));
  this_ptr->add_disjunct(*d_ptr);
}
CATCH_ALL








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_drop_1disjunct
(JNIEnv* env, jobject j_this, jobject j_it) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Pointset_Powerset<C_Polyhedron>::iterator& itr
    = *(reinterpret_cast<Pointset_Powerset<C_Polyhedron>::iterator*>(get_ptr(env, j_it)));
  itr = this_ptr->drop_disjunct(itr);
}
CATCH_ALL






JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_drop_1disjuncts
(JNIEnv* env, jobject j_this, jobject j_first, jobject j_last) try {
  Pointset_Powerset<C_Polyhedron>::iterator* first_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>::iterator*>(get_ptr(env, j_first));
  Pointset_Powerset<C_Polyhedron>::iterator* last_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>::iterator*>(get_ptr(env, j_last));
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  this_ptr->drop_disjuncts(*first_ptr, *last_ptr);
}
CATCH_ALL






JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_BHZ03_1BHRZ03_1BHRZ03_1widening_1assign
(JNIEnv* env, jobject j_this, jobject j_y) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Pointset_Powerset<C_Polyhedron>* y_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
  this_ptr->BHZ03_widening_assign<BHRZ03_Certificate>
    (*y_ptr,
     widen_fun_ref(
       &C_Polyhedron::BHRZ03_widening_assign));
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_BHZ03_1H79_1H79_1widening_1assign
(JNIEnv* env, jobject j_this, jobject j_y) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Pointset_Powerset<C_Polyhedron>* y_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
  this_ptr->BHZ03_widening_assign<H79_Certificate>
    (*y_ptr,
     widen_fun_ref(
       &C_Polyhedron::H79_widening_assign));
}
CATCH_ALL








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_BGP99_1BHRZ03_1extrapolation_1assign
(JNIEnv* env, jobject j_this, jobject j_y, jobject j_disjuncts) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Pointset_Powerset<C_Polyhedron>* y_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
  unsigned int disjuncts =
    jtype_to_unsigned<unsigned int>(j_integer_to_j_int(env, j_disjuncts));
  this_ptr->BGP99_extrapolation_assign
    (*y_ptr,
     widen_fun_ref(&C_Polyhedron::BHRZ03_widening_assign),
     disjuncts);
}
CATCH_ALL

JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_BGP99_1H79_1extrapolation_1assign
(JNIEnv* env, jobject j_this, jobject j_y, jobject j_disjuncts) try {
  Pointset_Powerset<C_Polyhedron>* this_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
  Pointset_Powerset<C_Polyhedron>* y_ptr
    = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_y));
  unsigned int disjuncts =
    jtype_to_unsigned<unsigned int>(j_integer_to_j_int(env, j_disjuncts));
  this_ptr->BGP99_extrapolation_assign
    (*y_ptr,
     widen_fun_ref(&C_Polyhedron::H79_widening_assign),
     disjuncts);
}
CATCH_ALL








JNIEXPORT void JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_free
(JNIEnv* env, jobject j_this) try {
  if (!is_java_marked(env, j_this)) {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    delete this_ptr;
    void* null_ptr = 0;
    set_ptr(env, j_this, null_ptr);
  }
}
CATCH_ALL






JNIEXPORT jint JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_hashCode
(JNIEnv* env, jobject j_this) {
  try {
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    return this_ptr->hash_code();
  }
  CATCH_ALL;
  return 0;
}





JNIEXPORT jstring JNICALL
Java_parma_1polyhedra_1library_Pointset_1Powerset_1C_1Polyhedron_toString
(JNIEnv* env, jobject j_this) {
  try {
    using namespace Parma_Polyhedra_Library::IO_Operators;
    Pointset_Powerset<C_Polyhedron>* this_ptr
      = reinterpret_cast<Pointset_Powerset<C_Polyhedron>*>(get_ptr(env, j_this));
    std::ostringstream s;
    s << *this_ptr;
    std::string str = s.str();
    return env->NewStringUTF(str.c_str());
  }
  CATCH_ALL;
  return 0;
}







